[leetcode] 377. Combination Sum IV

Given an integer array with all positive numbers and no duplicates, find the number of possible combinations that add up to a positive integer target.

Example:

nums = [1, 2, 3]
target = 4

The possible combination ways are:
(1, 1, 1, 1)
(1, 1, 2)
(1, 2, 1)
(1, 3)
(2, 1, 1)
(2, 2)
(3, 1)

Note that different sequences are counted as different combinations.

Therefore the output is 7.

Follow up:
What if negative numbers are allowed in the given array?
How does it change the problem?
What limitation we need to add to the question to allow negative numbers?


解法一:

recursive的思路,如果target和当前数字相等,则加1,否则用target-nuns[i]再次遍历。

不过这个方法不能通过OJ的runtime test。sigh。

class Solution {
public:
    int combinationSum4(vector<int>& nums, int target) {
        int cnt = 0;
        if (target<0) return cnt;
        for(int i=0; i<nums.size(); ++i){
            if(target==nums[i]) cnt++;
            else cnt+= combinationSum4(nums,target-nums[i]);
        }
        return cnt;
    }
};

解法二:

dp的思路。从数字1到target遍历一遍。对于没一个数字i,遍历数组。数组中每一个元素a组成i的方法数是dp[i-a]。

class Solution {
public:
    int combinationSum4(vector<int>& nums, int target) {
        vector<int> dp(target+1);
        dp[0]=1;
        
        for(int i=1; i<=target; ++i){
            for(auto a:nums){
                if (i>=a) dp[i]+=dp[i-a];
            }
        }
        return dp.back();
        
    }
};


评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值